//+------------------------------------------------------------------
//|flat trend mt4
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"


#property indicator_separate_window
#property indicator_buffers 3
#property indicator_minimum 0
#property indicator_maximum 1
#property indicator_color1  C'13,13,65'
#property indicator_color2  C'65,13,13'
#property indicator_color3  LightGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2

//
//
//
//
//

extern ENUM_TIMEFRAMES    TimeFrame       = PERIOD_CURRENT;
extern int                FastEMA         = 12;
extern int                SlowEMA         = 26;
extern int                SignalEMA       = 9;
extern ENUM_APPLIED_PRICE Price           = PRICE_CLOSE;
extern bool               alertsOn        = false;    // Turn alerts on
extern bool               alertsOnCurrent = true;     // Alerts on currnt (still opened) bar
extern bool               alertsMessage   = true;     // Aleert should show pop-up message
extern bool               alertsSound     = false;    // Alerts should play alert sound
extern bool               alertsPushNotif = false;    // Alerts should send push notification
extern bool               alertsEmail     = false;    // Alerts should send email

//
//
//
//
//

double Buffer1[];
double Buffer2[];
double Buffer3[];
double macd[];
double signal[];
double trend[];

string indicatorFileName;
bool   returnBars;


//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,Buffer1); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,Buffer2); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,Buffer3); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(4,macd);
   SetIndexBuffer(5,signal);
   SetIndexBuffer(6,trend);
   
       //
       //
       //
       //
       //
      
       indicatorFileName = WindowExpertName();
       returnBars        = TimeFrame==-99;
       TimeFrame         = MathMax(TimeFrame,_Period);
       
       //
       //
       //
       //
       // 

       IndicatorShortName(timeFrameToString(TimeFrame)+"  Flat Trend Macd");  
return(0);
}

//
//
//
//
//

int deinit()  { return(0);  }

//
//
//
//
//
 
double emas[][2];  
int start()
{
   int counted_bars=IndicatorCounted();
   int i,r,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);
           if (returnBars) { Buffer1[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (TimeFrame==Period())
   {
      if (ArrayRange(emas,0) != Bars) ArrayResize(emas,Bars);
      double alphaSign = 2.0/(1.0+SignalEMA);
      double alphaFast = 2.0/(1.0+FastEMA);
      double alphaSlow = 2.0/(1.0+SlowEMA);
      for (i = limit, r=Bars-i-1; i>=0 ; i--,r++)
      {
         double price = iMA(NULL,0,1,0,MODE_SMA,Price,i);
         if (i>Bars-2)
         {
            emas[r][0] = price;
            emas[r][1] = price;
            macd[i]    = 0;
            signal[i]  = 0;
            continue;
         }

         //
         //
         //
         //
         //
         
         emas[r][0] = emas[r-1][0]+alphaFast*(price-emas[r-1][0]);
         emas[r][1] = emas[r-1][1]+alphaSlow*(price-emas[r-1][1]);
         macd[i]    = emas[r][0]-emas[r][1];
         signal[i]  = signal[i+1]+alphaSign*(macd[i]-signal[i+1]);
   
         Buffer1[i]=EMPTY_VALUE;
         Buffer2[i]=EMPTY_VALUE;
         Buffer3[i]=EMPTY_VALUE;
         trend[i] = trend[i+1];
   
         if ( macd[i]>signal[i] && macd[i]>0)                                       trend[i]  = 1;   
         if ( macd[i]<signal[i] && macd[i]<0)                                       trend[i]  =-1; 
         if ((macd[i]>signal[i] && macd[i]<0) || (macd[i]<signal[i] && macd[i]>0))  trend[i]  = 0;
         if (trend[i] == 1) Buffer1[i] = 1;
         if (trend[i] ==-1) Buffer2[i] = 1;
         if (trend[i] == 0) Buffer3[i] = 1;
         
       }
    manageAlerts();
    return(0);
    }   

   //
   //
   //
   //
   //

   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,TimeFrame,indicatorFileName,-99,0,0)*TimeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,TimeFrame,Time[i]);
         Buffer1[i] = EMPTY_VALUE;
         Buffer2[i] = EMPTY_VALUE;
         Buffer3[i] = EMPTY_VALUE;
         trend[i]   = iCustom(NULL,TimeFrame,indicatorFileName,PERIOD_CURRENT,FastEMA,SlowEMA,SignalEMA,Price,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsPushNotif,alertsEmail,6,y); 
            if (trend[i] == 1) Buffer1[i] = 1;
            if (trend[i] ==-1) Buffer2[i] = 1;
            if (trend[i] == 0) Buffer3[i] = 1;
   }
return(0);
}
 
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M10","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,10,15,30,60,240,1440,10080,43200};

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      
      //
      //
      //
      //
      //
      
      
         if (trend[whichBar] != trend[whichBar+1])
         {
            if (trend[whichBar] == 1) doAlert(whichBar,"strong up");
            if (trend[whichBar] ==-1) doAlert(whichBar,"strong down");
            if (trend[whichBar] == 0) doAlert(whichBar,"weak");
         }                
   }
}   

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
      if (previousAlert != doWhat || previousTime != Time[forBar]) {
          previousAlert  = doWhat;
          previousTime   = Time[forBar];

          //
          //
          //
          //
          //

          message =  StringConcatenate(Symbol()," ",timeFrameToString(_Period)," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," Flat Trend macd ",doWhat);
             if (alertsMessage)   Alert(message);
             if (alertsEmail)     SendMail(StringConcatenate(Symbol(),"Flat Trend macd"),message);
             if (alertsPushNotif) SendNotification(message);
             if (alertsSound)     PlaySound("alert2.wav");
      }
} 
 
   

